#include "opencv2/opencv.hpp"

#include "stattimer.hpp"
//STimerList st(STimerList::reporterTSV, "stat.txt");
STimerList st;


void invertGray(cv::Mat& image, int index)
{
    const int width = image.cols;
    const int height = image.rows;

    if (index % 2 == 0) {
        st.start("invert ptr sub");
        for (int j = 0; j < height; j++) {
            uchar *img_ptr = image.ptr<uchar>(j);
            for (int i = 0; i < width; i++) {
                img_ptr[i] = 255 - img_ptr[i];
            }
        }
        st.stop("invert ptr sub");
    } else {
        st.start("invert ptr negate");
        for (int j = 0; j < height; j++) {
            uchar *img_ptr = image.ptr<uchar>(j);
            for (int i = 0; i < width; i++) {
                img_ptr[i] = ~img_ptr[i];
            }
        }
        st.stop("invert ptr negate");
    }
}


int main()
{
    cv::namedWindow("display", cv::WINDOW_AUTOSIZE);
    cv::VideoCapture cap(0);
    cv::Mat image;
    cap >> image;

    int index = 0;
    while (1) {
        cap >> image;
        cv::cvtColor(image, image, CV_BGR2GRAY);

        invertGray(image, index);

        cv::imshow("display", image);
        int key;
        if ((key = cv::waitKey(30)) > 0) {
            if (key == 'q' || key == 0x1b) {
                break;
            }
        }

        index++;
    }

}
